#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "functions.h"
#include "util.h"
#include "plist.h"

void value(POINT *parent, POINT *point){
  POINT scratch_point;
  char string[1024];
  int i;

  if(Trace){ 
    our_printf("entered value()\n"); 
    ++Trace_level; 
  } 
  
  if(Trace){ 
    sprintf(string,"point %p\timeslice %i\n",point,point->timeslice);
    our_printf(string); 
  } 
  
  if(point->timeslice == Timeslices-1){ 
    point->value_if_held = 0;
    point->value_if_exercised = payoff(point);
    if(point->value_if_held > point->value_if_exercised){
      point->value = point->value_if_held;
    }else{
      point->value = point->value_if_exercised;
    }
    point->error = 0;
    point->delta_r            = point->value_if_exercised - point->value_if_held;
  }else{
    /* if the error is too large at this time add point */
    if(point->important_cluster.elements != 0){
      point->value_if_exercised = payoff(point);
      point->value_if_held      = mesh_estimate_value(point, &(point->error));  
      point->value = dMax(point->value_if_held,point->value_if_exercised);
      point->value = dMax(0,point->value);

      point->delta_r = point->value_if_exercised - point->value_if_held;
    }
    while(error_too_large(point)){
      for(i=1; i<= Growth_step; i++){
	point_initialize(&scratch_point);
	grow_point(point->price, scratch_point.price);
	add_point_to_mesh(&scratch_point, point, point->timeslice+1);
	value( point, &(Time[point->timeslice+1].element[ Time[point->timeslice+1].elements-1 ]));
	point_finalize(&scratch_point);
      }
      /* the new point is now the last point in the next timeslice */
      point->value_if_exercised = payoff(point);
      point->value_if_held      = mesh_estimate_value(point, &(point->error));  
      point->value = dMax(point->value_if_held,point->value_if_exercised);
      point->value = dMax(0,point->value);
      point->delta_r = point->value_if_exercised - point->value_if_held;
/*       printf("Value: value_if_held = %lf +/- %lf delta_r = %lf\n",point->value_if_held,point->error,point->delta_r); */

    }
  }
  
/*   printf("%i ",point->timeslice); */
/*   for(i=0;i<Dimensions;i++){ */
/*     printf("%lf ",point->price[i]); */
/*   } */
/*   if(point->value_if_held > point->value_if_exercised) */
/*     printf("0\n"); */
/*   else */
/*     printf("1\n"); */
/*   printf("%i\n",point->children.elements); */

/*
  for(i=0;i<point->timeslice;i++){
    printf("  ");
  }
  printf("[%d][%d] value = %g error = %g \n", point->timeslice, point->point_id,
         point->value, point->error);
*/

  if(Trace){ 
    --Trace_level;
    our_printf("exiting value()\n"); 
  } 

}      
    
